haskell-language-server-2.9.0.0: LSP server for GHC

Safe Haskell | None
Language | GHC2021

Experiments.Types

# Documentation

data Config #

Constructors

Config |

Fields

- verbosity :: !Verbosity
- shakeProfiling :: !(Maybe FilePath)
- otMemoryProfiling :: !(Maybe FilePath)
- outputCSV :: !FilePath
- buildTool :: !CabalStack
- ghcideOptions :: ![String]
- matches :: ![String]
- repetitions :: Maybe Natural
- ghcide :: FilePath
- timeoutLsp :: Int
- example :: Example
- lspConfig :: Bool

#### Instances

Instances details

Show Config # |
Instance details Defined in Experiments.Types Methods showsPrec :: Int -> Config -> ShowS # show :: Config -> String # showList :: [Config] -> ShowS #
Eq Config # |
Instance details Defined in Experiments.Types Methods (==) :: Config -> Config -> Bool # (/=) :: Config -> Config -> Bool #

data CabalStack #

Constructors

Cabal |
Stack |

#### Instances

Instances details

Show CabalStack # |
Instance details Defined in Experiments.Types Methods showsPrec :: Int -> CabalStack -> ShowS # show :: CabalStack -> String # showList :: [CabalStack] -> ShowS #
Eq CabalStack # |
Instance details Defined in Experiments.Types Methods (==) :: CabalStack -> CabalStack -> Bool # (/=) :: CabalStack -> CabalStack -> Bool #

data ExamplePackage #

Constructors

ExamplePackage |

Fields

- packageName :: !String
- packageVersion :: !Version

#### Instances

Instances details

Binary ExamplePackage # |
Instance details Defined in Experiments.Types Methods put :: ExamplePackage -> Put # get :: Get ExamplePackage # putList :: [ExamplePackage] -> Put #
NFData ExamplePackage # |
Instance details Defined in Experiments.Types Methods rnf :: ExamplePackage -> () #
Generic ExamplePackage # |

Instance details

Defined in Experiments.Types

Associated Types

type Rep ExamplePackage |

Instance details

Defined in Experiments.Types

type Rep ExamplePackage = D1 ('MetaData "ExamplePackage" "Experiments.Types" "haskell-language-server-2.9.0.0-AAqKnmVOPCtY0F1aqE44N-ghcide-bench-lib" 'False) (C1 ('MetaCons "ExamplePackage" 'PrefixI 'True) (S1 ('MetaSel ('Just "packageName") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 String) :*: S1 ('MetaSel ('Just "packageVersion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Version)))

Methods

from :: ExamplePackage -> Rep ExamplePackage x #

to :: Rep ExamplePackage x -> ExamplePackage #

Show ExamplePackage # |
Instance details Defined in Experiments.Types Methods showsPrec :: Int -> ExamplePackage -> ShowS # show :: ExamplePackage -> String # showList :: [ExamplePackage] -> ShowS #
Eq ExamplePackage # |
Instance details Defined in Experiments.Types Methods (==) :: ExamplePackage -> ExamplePackage -> Bool # (/=) :: ExamplePackage -> ExamplePackage -> Bool #
Hashable ExamplePackage # |
Instance details Defined in Experiments.Types Methods hashWithSalt :: Int -> ExamplePackage -> Int # hash :: ExamplePackage -> Int #
type Rep ExamplePackage # |

Instance details

Defined in Experiments.Types

type Rep ExamplePackage = D1 ('MetaData "ExamplePackage" "Experiments.Types" "haskell-language-server-2.9.0.0-AAqKnmVOPCtY0F1aqE44N-ghcide-bench-lib" 'False) (C1 ('MetaCons "ExamplePackage" 'PrefixI 'True) (S1 ('MetaSel ('Just "packageName") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 String) :*: S1 ('MetaSel ('Just "packageVersion") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 Version)))

data Verbosity #

Constructors

Quiet |
Normal |
All |

#### Instances

Instances details

Show Verbosity # |
Instance details Defined in Experiments.Types Methods showsPrec :: Int -> Verbosity -> ShowS # show :: Verbosity -> String # showList :: [Verbosity] -> ShowS #
Eq Verbosity # |
Instance details Defined in Experiments.Types Methods (==) :: Verbosity -> Verbosity -> Bool # (/=) :: Verbosity -> Verbosity -> Bool #

data Example #

Constructors

Example |

Fields

- exampleName :: !String
- exampleDetails :: ExampleDetails
- exampleModules :: [FilePath]
- exampleExtraArgs :: [String]

#### Instances

Instances details

FromJSON Example # |
Instance details Defined in Experiments.Types Methods parseJSON :: Value -> Parser Example # parseJSONList :: Value -> Parser [Example] # omittedField :: Maybe Example #
Binary Example # |
Instance details Defined in Experiments.Types Methods put :: Example -> Put # get :: Get Example # putList :: [Example] -> Put #
NFData Example # |
Instance details Defined in Experiments.Types Methods rnf :: Example -> () #
Generic Example # |

Instance details

Defined in Experiments.Types

Associated Types

type Rep Example |

Instance details

Defined in Experiments.Types

type Rep Example = D1 ('MetaData "Example" "Experiments.Types" "haskell-language-server-2.9.0.0-AAqKnmVOPCtY0F1aqE44N-ghcide-bench-lib" 'False) (C1 ('MetaCons "Example" 'PrefixI 'True) ((S1 ('MetaSel ('Just "exampleName") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 String) :*: S1 ('MetaSel ('Just "exampleDetails") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ExampleDetails)) :*: (S1 ('MetaSel ('Just "exampleModules") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [FilePath]) :*: S1 ('MetaSel ('Just "exampleExtraArgs") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [String]))))

Methods

from :: Example -> Rep Example x #

to :: Rep Example x -> Example #

Show Example # |
Instance details Defined in Experiments.Types Methods showsPrec :: Int -> Example -> ShowS # show :: Example -> String # showList :: [Example] -> ShowS #
Eq Example # |
Instance details Defined in Experiments.Types Methods (==) :: Example -> Example -> Bool # (/=) :: Example -> Example -> Bool #
Hashable Example # |
Instance details Defined in Experiments.Types Methods hashWithSalt :: Int -> Example -> Int # hash :: Example -> Int #
type Rep Example # |

Instance details

Defined in Experiments.Types

type Rep Example = D1 ('MetaData "Example" "Experiments.Types" "haskell-language-server-2.9.0.0-AAqKnmVOPCtY0F1aqE44N-ghcide-bench-lib" 'False) (C1 ('MetaCons "Example" 'PrefixI 'True) ((S1 ('MetaSel ('Just "exampleName") 'NoSourceUnpackedness 'SourceStrict 'DecidedStrict) (Rec0 String) :*: S1 ('MetaSel ('Just "exampleDetails") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ExampleDetails)) :*: (S1 ('MetaSel ('Just "exampleModules") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [FilePath]) :*: S1 ('MetaSel ('Just "exampleExtraArgs") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [String]))))

exampleToOptions :: Example -> [String] -> [String] #

data ExampleDetails #

Constructors

ExamplePath FilePath | directory where the package is located
ExampleHackage ExamplePackage | package from hackage
ExampleScript |

Fields

- FilePath

  location of the script we are running

- [String]

  extra arguments for the script

#### Instances

Instances details

Binary ExampleDetails # |
Instance details Defined in Experiments.Types Methods put :: ExampleDetails -> Put # get :: Get ExampleDetails # putList :: [ExampleDetails] -> Put #
NFData ExampleDetails # |
Instance details Defined in Experiments.Types Methods rnf :: ExampleDetails -> () #
Generic ExampleDetails # |

Instance details

Defined in Experiments.Types

Associated Types

type Rep ExampleDetails |

Instance details

Defined in Experiments.Types

type Rep ExampleDetails = D1 ('MetaData "ExampleDetails" "Experiments.Types" "haskell-language-server-2.9.0.0-AAqKnmVOPCtY0F1aqE44N-ghcide-bench-lib" 'False) (C1 ('MetaCons "ExamplePath" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 FilePath)) :+: (C1 ('MetaCons "ExampleHackage" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ExamplePackage)) :+: C1 ('MetaCons "ExampleScript" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 FilePath) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [String]))))

Methods

from :: ExampleDetails -> Rep ExampleDetails x #

to :: Rep ExampleDetails x -> ExampleDetails #

Show ExampleDetails # |
Instance details Defined in Experiments.Types Methods showsPrec :: Int -> ExampleDetails -> ShowS # show :: ExampleDetails -> String # showList :: [ExampleDetails] -> ShowS #
Eq ExampleDetails # |
Instance details Defined in Experiments.Types Methods (==) :: ExampleDetails -> ExampleDetails -> Bool # (/=) :: ExampleDetails -> ExampleDetails -> Bool #
Hashable ExampleDetails # |
Instance details Defined in Experiments.Types Methods hashWithSalt :: Int -> ExampleDetails -> Int # hash :: ExampleDetails -> Int #
type Rep ExampleDetails # |

Instance details

Defined in Experiments.Types

type Rep ExampleDetails = D1 ('MetaData "ExampleDetails" "Experiments.Types" "haskell-language-server-2.9.0.0-AAqKnmVOPCtY0F1aqE44N-ghcide-bench-lib" 'False) (C1 ('MetaCons "ExamplePath" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 FilePath)) :+: (C1 ('MetaCons "ExampleHackage" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ExamplePackage)) :+: C1 ('MetaCons "ExampleScript" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 FilePath) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [String]))))